/*****************************************************/
/* hp550c.c                                          */
/* -- Program repros the paper select escape bug     */
/*    with the HP 550C printer driver.               */
/*****************************************************/
#include <windows.h>
#include <commdlg.h>
#include <print.h>

void ShowMetrics(HDC hdc);

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
  LPSTR lpsz, int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
{
    LPDEVMODE lpdvm;
    PRINTDLG pdg;

    pdg.lStructSize = sizeof pdg;
    pdg.hwndOwner = NULL;
    pdg.hDevMode = NULL;
    pdg.hDevNames = NULL;
    pdg.hDC = NULL;
    pdg.Flags = PD_RETURNDC | PD_RETURNDEFAULT;
    pdg.nFromPage = 0;
    pdg.nToPage = 0;
    pdg.nMinPage = 0;
    pdg.nMaxPage = 0;
    pdg.nCopies = 0;
    pdg.hInstance = NULL;
    pdg.lCustData = NULL;
    pdg.lpfnPrintHook = NULL;
    pdg.lpfnSetupHook = NULL;
    pdg.lpPrintTemplateName = NULL;
    pdg.lpSetupTemplateName = NULL;
    pdg.hPrintTemplate = NULL;
    pdg.hSetupTemplate = NULL;
	if (!PrintDlg(&pdg))
        return FALSE;

    ShowMetrics(pdg.hDC);
    lpdvm = (LPDEVMODE)GlobalLock(pdg.hDevMode);
    lpdvm->dmPaperSize = DMPAPER_USER;
    lpdvm->dmPaperWidth = 2159; /* 8.5 * 254 */
    lpdvm->dmPaperLength = 2794; /* 11 * 254 */
    ResetDC(pdg.hDC, lpdvm);
    ShowMetrics(pdg.hDC);

    DeleteDC(pdg.hDC);
    GlobalFree(pdg.hDevMode);
    GlobalFree(pdg.hDevNames);
    return TRUE;
}

void ShowMetrics(HDC hdc)
/*****************************************************/
/* -- Display the paper metrics for the printer.     */
/*****************************************************/
{
    POINT pt;
    char szBuf[512];

    Escape(hdc,  GETPRINTINGOFFSET, NULL, NULL,
      (LPVOID)&pt);
    wsprintf(szBuf, "VERTRES %d\n HORZRES %d\n"
        " PRINTINGOFFSET (%d, %d)",
      GetDeviceCaps(hdc, VERTRES),
      GetDeviceCaps(hdc, HORZRES), pt.x, pt.y);
    MessageBox(NULL, szBuf, "Paper Metrics", MB_OK);
}
